Index: /palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 2291)
+++ /palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 2292)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
+! includes two more prognostic equations for cloud drop concentration (nc)  
+! and cloud water content (qc). 
+! 
+! 2270 2017-06-09 12:18:47Z maronga
 ! Removed 2 timeseries (shf_eb + qsws_eb). Removed _eb suffixes
 ! 
@@ -844,6 +849,6 @@
 !
 !--             Most variables are defined on the scalar grid
-                CASE ( 'e', 'lpt', 'nr', 'p', 'pc', 'pr', 'prr', 'pt', 'q',    &
-                       'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',        &
+                CASE ( 'e', 'lpt', 'nc', 'nr', 'p', 'pc', 'pr', 'prr', 'pt',   &
+                       'q', 'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',   &
                        'rho_ocean', 's', 'sa', 'vpt'  )
 
@@ -1376,7 +1381,7 @@
 !
 !--             Most variables are defined on the scalar grid
-                CASE ( 'e', 'lpt', 'nr', 'p', 'pc', 'pr', 'prr', 'pt', 'q',    &
-                       'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv', 'rho_ocean', &
-                       's', 'sa', 'vpt' )
+                CASE ( 'e', 'lpt', 'nc', 'nr', 'p', 'pc', 'pr', 'prr', 'pt',   &
+                       'q', 'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',   &
+                       'rho_ocean', 's', 'sa', 'vpt' )
 
                    grid_x = 'x'
@@ -2027,9 +2032,9 @@
 !
 !--                   Most variables are defined on the zu grid
-                      CASE ( 'e_xy', 'lpt_xy', 'nr_xy', 'p_xy', 'pc_xy',       &
-                             'pr_xy', 'prr_xy', 'pt_xy', 'q_xy', 'qc_xy',      &
-                             'ql_xy', 'ql_c_xy', 'ql_v_xy', 'ql_vp_xy',        &
-                             'qr_xy', 'qv_xy', 'rho_ocean_xy', 's_xy',         &
-                             'sa_xy', 'vpt_xy' )
+                      CASE ( 'e_xy', 'lpt_xy', 'nc_xy', 'nr_xy', 'p_xy',       &
+                             'pc_xy', 'pr_xy', 'prr_xy', 'pt_xy', 'q_xy',      &
+                             'qc_xy', 'ql_xy', 'ql_c_xy', 'ql_v_xy',           &
+                             'ql_vp_xy', 'qr_xy', 'qv_xy', 'rho_ocean_xy',     &
+                             's_xy', 'sa_xy', 'vpt_xy' )
 
                          grid_x = 'x'
@@ -2726,8 +2731,8 @@
 !
 !--                Most variables are defined on the zu grid
-                   CASE ( 'e_xz', 'lpt_xz', 'nr_xz', 'p_xz', 'pc_xz', 'pr_xz', &
-                          'prr_xz', 'pt_xz', 'q_xz', 'qc_xz', 'ql_xz',         &
-                          'ql_c_xz', 'ql_v_xz', 'ql_vp_xz', 'qr_xz', 'qv_xz',  &
-                          'rho_ocean_xz', 's_xz', 'sa_xz', 'vpt_xz' )
+                   CASE ( 'e_xz', 'lpt_xz', 'nc_xz', 'nr_xz', 'p_xz', 'pc_xz', &
+                          'pr_xz', 'prr_xz', 'pt_xz', 'q_xz', 'qc_xz',         &
+                          'ql_xz', 'ql_c_xz', 'ql_v_xz', 'ql_vp_xz', 'qr_xz',  &
+                          'qv_xz', 'rho_ocean_xz', 's_xz', 'sa_xz', 'vpt_xz' )
 
                       grid_x = 'x'
@@ -3380,6 +3385,6 @@
 !
 !--                Most variables are defined on the zu grid
-                   CASE ( 'e_yz', 'lpt_yz', 'nr_yz', 'p_yz', 'pc_yz', 'pr_yz', &
-                          'prr_yz', 'pt_yz', 'q_yz', 'qc_yz', 'ql_yz',         &
+                   CASE ( 'e_yz', 'lpt_yz', 'nc_yz', 'nr_yz', 'p_yz', 'pc_yz', &
+                          'pr_yz','prr_yz', 'pt_yz', 'q_yz', 'qc_yz', 'ql_yz', &
                           'ql_c_yz', 'ql_v_yz', 'ql_vp_yz', 'qr_yz', 'qv_yz',  &
                           'rho_ocean_yz', 's_yz', 'sa_yz', 'vpt_yz' )
@@ -4557,6 +4562,6 @@
 !
 !--             Most variables are defined on the zu levels
-                CASE ( 'e', 'lpt', 'nr', 'p', 'pc', 'pr', 'prr', 'pt', 'q',    &
-                       'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',        &
+                CASE ( 'e', 'lpt', 'nc', 'nr', 'p', 'pc', 'pr', 'prr', 'pt',   &
+                       'q', 'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',   &
                        'rho_ocean', 's', 'sa', 'u', 'v', 'vpt' )
 
Index: /palm/trunk/SOURCE/palm.f90
===================================================================
--- /palm/trunk/SOURCE/palm.f90	(revision 2291)
+++ /palm/trunk/SOURCE/palm.f90	(revision 2292)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
+! includes two more prognostic equations for cloud drop concentration (nc)  
+! and cloud water content (qc). 
+! 
+! 2261 2017-06-08 14:25:57Z raasch
 ! output of run number for mrun to create unified cycle numbers
 ! 
@@ -177,7 +182,7 @@
                do2d_at_begin, do3d_at_begin, humidity, initializing_actions,   &
                io_blocks, io_group, land_surface, large_scale_forcing,         &
-               message_string, microphysics_seifert, nest_domain, neutral,     &
-               nudging, passive_scalar, runnr, simulated_time,                 &
-               simulated_time_chr, urban_surface,                              &
+               message_string, microphysics_morrison, microphysics_seifert,    &
+               nest_domain, neutral, nudging, passive_scalar, runnr,           &
+               simulated_time, simulated_time_chr, urban_surface,              &
                user_interface_current_revision,                                &
                user_interface_required_revision, version, wall_heatflux,       &
@@ -364,8 +369,10 @@
              IF ( humidity )  THEN
                 CALL exchange_horiz( q, nbgp )
+                IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                  CALL exchange_horiz( qc, nbgp )
+                  CALL exchange_horiz( nc, nbgp )
+                ENDIF
                 IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!                   CALL exchange_horiz( qc, nbgp )
                    CALL exchange_horiz( qr, nbgp ) 
-!                   CALL exchange_horiz( nc, nbgp )
                    CALL exchange_horiz( nr, nbgp )
                 ENDIF
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 2291)
+++ /palm/trunk/SOURCE/parin.f90	(revision 2292)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
+! includes two more prognostic equations for cloud drop concentration (nc)  
+! and cloud water content (qc). 
+! 
+! 2267 2017-06-09 09:33:25Z gronemeier
 ! Bugfix: removed skipping of reading namelists in case of omitted d3par
 ! 
@@ -292,6 +297,6 @@
     USE microphysics_mod,                                                      &
         ONLY:  c_sedimentation, cloud_water_sedimentation,                     &
-               collision_turbulence, limiter_sedimentation, nc_const,          &
-               ventilation_effect
+               collision_turbulence, curvature_solution_effects_bulk,          &
+               limiter_sedimentation ,na_init, nc_const, ventilation_effect
 
     USE model_1d,                                                              &
@@ -350,5 +355,5 @@
              collective_wait, collision_turbulence, conserve_volume_flow,      &
              conserve_volume_flow_mode, constant_flux_layer,                   &
-             coupling_start_time,                                              &
+             coupling_start_time, curvature_solution_effects_bulk,             &
              cycle_mg, damp_level_1d,                                          &
              dissipation_1d,                                                   &
@@ -366,5 +371,5 @@
              loop_optimization, lsf_exception, masking_method, mg_cycles,      &
              mg_switch_to_pe0_level, mixing_length_1d, momentum_advec,         &
-             most_method, nc_const, netcdf_precision, neutral, ngsrb,          &
+             most_method, na_init, nc_const, netcdf_precision, neutral, ngsrb, &
              nsor, nsor_ini, nudging, nx, ny, nz, ocean, omega, omega_sor,     &
              outflow_source_plane, passive_scalar, phi,                        &
Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2291)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2292)
@@ -26,4 +26,9 @@
 ! -----------------
 ! $Id$
+! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
+! includes two more prognostic equations for cloud drop concentration (nc)  
+! and cloud water content (qc). 
+! 
+! 2285 2017-06-15 13:15:41Z suehring
 ! Consider multiple pure-vertical nest domains in overlap check
 ! 
@@ -154,18 +159,19 @@
 #if defined( __nopointer )
     USE arrays_3d,                                                             &
-        ONLY:  dzu, dzw, e, e_p, nr, pt, pt_p, q, q_p, qr, u, u_p, v, v_p,     &
-               w, w_p, zu, zw
+        ONLY:  dzu, dzw, e, e_p, nc, nr, pt, pt_p, q, q_p, qc, qr, u, u_p, v,  &
+               v_p, w, w_p, zu, zw
 #else
    USE arrays_3d,                                                              &
-        ONLY:  dzu, dzw, e, e_p, e_1, e_2, nr, nr_2, nr_p, pt, pt_p, pt_1,     &
-               pt_2, q, q_p, q_1, q_2, qr, qr_2, s, s_2, u, u_p, u_1, u_2, v,  &
-               v_p, v_1, v_2, w, w_p, w_1, w_2, zu, zw
+        ONLY:  dzu, dzw, e, e_p, e_1, e_2, nc, nc_2, nc_p, nr, nr_2, nr_p, pt, &
+               pt_p, pt_1, pt_2, q, q_p, q_1, q_2, qc, qc_2, qr, qr_2, s, s_2, &
+               u, u_p, u_1, u_2, v, v_p, v_1, v_2, w, w_p, w_1, w_2, zu, zw
 #endif
 
     USE control_parameters,                                                     &
         ONLY:  cloud_physics, coupling_char, dt_3d, dz, humidity,               &
-               message_string, microphysics_seifert, nest_bound_l, nest_bound_r,&
-               nest_bound_s, nest_bound_n, nest_domain, neutral, passive_scalar,& 
-               roughness_length, simulated_time, topography, volume_flow
+               message_string, microphysics_morrison, microphysics_seifert,     &
+               nest_bound_l, nest_bound_r, nest_bound_s, nest_bound_n,          &
+               nest_domain, neutral, passive_scalar, roughness_length,          &
+               simulated_time, topography, volume_flow
 
     USE cpulog,                                                                 &
@@ -281,8 +287,8 @@
     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  wc   !:
     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_c  !:
-!     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qcc  !:
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qcc  !:
     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qrc  !:
     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nrc  !:
-!     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ncc  !:
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ncc  !:
     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sc   !:
 
@@ -966,10 +972,12 @@
           CALL pmc_set_dataarray_name( 'coarse', 'q'  ,'fine', 'q',  ierr )
 
+          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+            CALL pmc_set_dataarray_name( 'coarse', 'qc'  ,'fine', 'qc',  ierr )  
+            CALL pmc_set_dataarray_name( 'coarse', 'nc'  ,'fine', 'nc',  ierr ) 
+          ENDIF
+
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!              CALL pmc_set_dataarray_name( 'coarse', 'qc'  ,'fine', 'qc',  ierr )  
              CALL pmc_set_dataarray_name( 'coarse', 'qr'  ,'fine', 'qr',  ierr )
-!             CALL pmc_set_dataarray_name( 'coarse', 'nc'  ,'fine', 'nc',  ierr ) 
              CALL pmc_set_dataarray_name( 'coarse', 'nr'  ,'fine', 'nr',  ierr ) 
-
           ENDIF
      
@@ -2990,8 +2998,8 @@
     IF ( TRIM(name) == "pt" )  p_3d => pt
     IF ( TRIM(name) == "q"  )  p_3d => q
-!     IF ( TRIM(name) == "qc" )  p_3d => qc
+    IF ( TRIM(name) == "qc" )  p_3d => qc
     IF ( TRIM(name) == "qr" )  p_3d => qr
     IF ( TRIM(name) == "nr" )  p_3d => nr
-!     IF ( TRIM(name) == "nc" )  p_3d => nc
+    IF ( TRIM(name) == "nc" )  p_3d => nc
     IF ( TRIM(name) == "s"  )  p_3d => s
 !
@@ -3026,8 +3034,8 @@
     IF ( TRIM(name) == "pt" )  p_3d_sec => pt_2
     IF ( TRIM(name) == "q"  )  p_3d_sec => q_2
-!     IF ( TRIM(name) == "qc" )  p_3d_sec => qc_2
+    IF ( TRIM(name) == "qc" )  p_3d_sec => qc_2
     IF ( TRIM(name) == "qr" )  p_3d_sec => qr_2
     IF ( TRIM(name) == "nr" )  p_3d_sec => nr_2
-!     IF ( TRIM(name) == "nc" )  p_3d_sec => nc_2
+    IF ( TRIM(name) == "nc" )  p_3d_sec => nc_2
     IF ( TRIM(name) == "s"  )  p_3d_sec => s_2
 
@@ -3102,7 +3110,7 @@
        IF ( .NOT. ALLOCATED( q_c ) ) ALLOCATE( q_c(0:nzc+1, js:je, is:ie) )
        p_3d => q_c
-!     ELSEIF ( TRIM( name ) == "qc")  THEN
-!        IF ( .NOT. ALLOCATED( qcc ) ) ALLOCATE( qcc(0:nzc+1, js:je, is:ie) )
-!        p_3d => qcc
+    ELSEIF ( TRIM( name ) == "qc")  THEN
+       IF ( .NOT. ALLOCATED( qcc ) ) ALLOCATE( qcc(0:nzc+1, js:je, is:ie) )
+       p_3d => qcc
     ELSEIF ( TRIM( name ) == "qr")  THEN
        IF ( .NOT. ALLOCATED( qrc ) ) ALLOCATE( qrc(0:nzc+1, js:je, is:ie) )
@@ -3111,7 +3119,7 @@
        IF ( .NOT. ALLOCATED( nrc ) ) ALLOCATE( nrc(0:nzc+1, js:je, is:ie) )
        p_3d => nrc
-!     ELSEIF ( TRIM( name ) == "nc")  THEN
-!        IF ( .NOT. ALLOCATED( ncc ) ) ALLOCATE( ncc(0:nzc+1, js:je, is:ie) )
-!        p_3d => ncc
+    ELSEIF ( TRIM( name ) == "nc")  THEN
+       IF ( .NOT. ALLOCATED( ncc ) ) ALLOCATE( ncc(0:nzc+1, js:je, is:ie) )
+       p_3d => ncc
     ELSEIF ( TRIM( name ) == "s")  THEN
        IF ( .NOT. ALLOCATED( sc ) ) ALLOCATE( sc(0:nzc+1, js:je, is:ie) )
@@ -3224,11 +3232,14 @@
                                       r2yo, r1zo, r2zo, 's' )
 
+          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+             CALL pmci_interp_tril_all ( qc, qcc, ico, jco, kco, r1xo, r2xo,    &
+                                          r1yo, r2yo, r1zo, r2zo, 's' ) 
+             CALL pmci_interp_tril_all ( nc, ncc, ico, jco, kco, r1xo, r2xo,    &
+                                         r1yo, r2yo, r1zo, r2zo, 's' )   
+          ENDIF
+
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!              CALL pmci_interp_tril_all ( qc, qcc, ico, jco, kco, r1xo, r2xo,    &
-!                                          r1yo, r2yo, r1zo, r2zo, 's' ) 
              CALL pmci_interp_tril_all ( qr, qrc, ico, jco, kco, r1xo, r2xo,    &
                                          r1yo, r2yo, r1zo, r2zo, 's' )
-!             CALL pmci_interp_tril_all ( nc, ncc, ico, jco, kco, r1xo, r2xo,    &
-!                                         r1yo, r2yo, r1zo, r2zo, 's' )   
              CALL pmci_interp_tril_all ( nr, nrc, ico, jco, kco, r1xo, r2xo,    &
                                          r1yo, r2yo, r1zo, r2zo, 's' )
@@ -3955,12 +3966,19 @@
                                           nzt_topo_nestbc_l, 'l', 's' )
 
+                IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                   CALL pmci_interp_tril_lr( qc, qcc, ico, jco, kco, r1xo, r2xo,&
+                                             r1yo, r2yo, r1zo, r2zo,            &
+                                             logc_u_l,                          &
+                                             logc_ratio_u_l, nzt_topo_nestbc_l, &
+                                             'l', 's' )  
+
+                   CALL pmci_interp_tril_lr( nc, ncc, ico, jco, kco, r1xo, r2xo,&
+                                             r1yo, r2yo, r1zo, r2zo,            &
+                                             logc_u_l,                          &
+                                             logc_ratio_u_l, nzt_topo_nestbc_l, &
+                                             'l', 's' )          
+                ENDIF
 
                 IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!                    CALL pmci_interp_tril_lr( qc, qcc, ico, jco, kco, r1xo, r2xo,&
-!                                              r1yo, r2yo, r1zo, r2zo,            &
-!                                              logc_u_l,                          &
-!                                              logc_ratio_u_l, nzt_topo_nestbc_l, &
-!                                              'l', 's' )  
-
                    CALL pmci_interp_tril_lr( qr, qrc, ico, jco, kco, r1xo, r2xo,&
                                              r1yo, r2yo, r1zo, r2zo,            &
@@ -3968,10 +3986,4 @@
                                              logc_ratio_u_l, nzt_topo_nestbc_l, &
                                              'l', 's' ) 
-
-!                    CALL pmci_interp_tril_lr( nc, ncc, ico, jco, kco, r1xo, r2xo,&
-!                                              r1yo, r2yo, r1zo, r2zo,            &
-!                                              logc_u_l,                          &
-!                                              logc_ratio_u_l, nzt_topo_nestbc_l, &
-!                                              'l', 's' ) 
 
                    CALL pmci_interp_tril_lr( nr, nrc, ico, jco, kco, r1xo, r2xo,&
@@ -4004,9 +4016,14 @@
                    CALL pmci_extrap_ifoutflow_lr( q, 'l', 's' )
 
+                   IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+
+                      CALL pmci_extrap_ifoutflow_lr( qc, 'l', 's' )
+                      CALL pmci_extrap_ifoutflow_lr( nc, 'l', 's' )
+
+                   ENDIF
+
                    IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
 
-!                       CALL pmci_extrap_ifoutflow_lr( qc, 'l', 's' )
                       CALL pmci_extrap_ifoutflow_lr( qr, 'l', 's' )
-!                      CALL pmci_extrap_ifoutflow_lr( nc, 'l', 's' )
                       CALL pmci_extrap_ifoutflow_lr( nr, 'l', 's' )
 
@@ -4061,12 +4078,23 @@
                                           nzt_topo_nestbc_r, 'r', 's' )
 
+                IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+
+                   CALL pmci_interp_tril_lr( qc, qcc, ico, jco, kco, r1xo,     &
+                                             r2xo, r1yo, r2yo, r1zo, r2zo,     &
+                                             logc_u_r,                         &
+                                             logc_ratio_u_r, nzt_topo_nestbc_r,&
+                                             'r', 's' ) 
+     
+                   CALL pmci_interp_tril_lr( nc, ncc, ico, jco, kco, r1xo,     &
+                                             r2xo, r1yo, r2yo, r1zo, r2zo,     &
+                                             logc_u_r,                         &
+                                             logc_ratio_u_r, nzt_topo_nestbc_r,&
+                                             'r', 's' ) 
+
+
+                ENDIF
 
                 IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
 
-!                    CALL pmci_interp_tril_lr( qc, qcc, ico, jco, kco, r1xo,     &
-!                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-!                                              logc_u_r,                         &
-!                                              logc_ratio_u_r, nzt_topo_nestbc_r,&
-!                                              'r', 's' ) 
      
                    CALL pmci_interp_tril_lr( qr, qrc, ico, jco, kco, r1xo,     &
@@ -4076,10 +4104,4 @@
                                              'r', 's' ) 
 
-!                    CALL pmci_interp_tril_lr( nc, ncc, ico, jco, kco, r1xo,     &
-!                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-!                                              logc_u_r,                         &
-!                                              logc_ratio_u_r, nzt_topo_nestbc_r,&
-!                                              'r', 's' ) 
-
                    CALL pmci_interp_tril_lr( nr, nrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
@@ -4113,8 +4135,11 @@
                    CALL pmci_extrap_ifoutflow_lr( q, 'r', 's' )
 
+                   IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                      CALL pmci_extrap_ifoutflow_lr( qc, 'r', 's' )
+                      CALL pmci_extrap_ifoutflow_lr( nc, 'r', 's' )  
+                   ENDIF
+
                    IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!                       CALL pmci_extrap_ifoutflow_lr( qc, 'r', 's' )
                       CALL pmci_extrap_ifoutflow_lr( qr, 'r', 's' )
-!                      CALL pmci_extrap_ifoutflow_lr( nc, 'r', 's' )  
                       CALL pmci_extrap_ifoutflow_lr( nr, 'r', 's' )
                    ENDIF
@@ -4162,11 +4187,21 @@
                                           nzt_topo_nestbc_s, 's', 's' )
 
+                IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+
+                   CALL pmci_interp_tril_sn( qc, qcc, ico, jco, kco, r1xo,     &
+                                             r2xo, r1yo,r2yo, r1zo, r2zo,      &
+                                             logc_u_s,                         &
+                                             logc_ratio_u_s, nzt_topo_nestbc_s,&
+                                             's', 's' )
+
+                   CALL pmci_interp_tril_sn( nc, ncc, ico, jco, kco, r1xo,     &
+                                             r2xo, r1yo,r2yo, r1zo, r2zo,      &
+                                             logc_u_s,                         &
+                                             logc_ratio_u_s, nzt_topo_nestbc_s,&
+                                             's', 's' )
+
+                ENDIF
+
                 IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-
-!                    CALL pmci_interp_tril_sn( qc, qcc, ico, jco, kco, r1xo,     &
-!                                              r2xo, r1yo,r2yo, r1zo, r2zo,      &
-!                                              logc_u_s,                         &
-!                                              logc_ratio_u_s, nzt_topo_nestbc_s,&
-!                                              's', 's' )
 
                    CALL pmci_interp_tril_sn( qr, qrc, ico, jco, kco, r1xo,     &
@@ -4175,10 +4210,4 @@
                                              logc_ratio_u_s, nzt_topo_nestbc_s,&
                                              's', 's' )
-
-!                    CALL pmci_interp_tril_sn( nc, ncc, ico, jco, kco, r1xo,     &
-!                                              r2xo, r1yo,r2yo, r1zo, r2zo,      &
-!                                              logc_u_s,                         &
-!                                              logc_ratio_u_s, nzt_topo_nestbc_s,&
-!                                              's', 's' )
 
                    CALL pmci_interp_tril_sn( nr, nrc, ico, jco, kco, r1xo,     &
@@ -4212,8 +4241,11 @@
                    CALL pmci_extrap_ifoutflow_sn( q,  's', 's' )
 
+                   IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                      CALL pmci_extrap_ifoutflow_sn( qc, 's', 's' ) 
+                      CALL pmci_extrap_ifoutflow_sn( nc, 's', 's' ) 
+                   ENDIF
+
                    IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!                       CALL pmci_extrap_ifoutflow_sn( qc, 's', 's' ) 
                       CALL pmci_extrap_ifoutflow_sn( qr, 's', 's' )      
-!                       CALL pmci_extrap_ifoutflow_sn( nc, 's', 's' ) 
                       CALL pmci_extrap_ifoutflow_sn( nr, 's', 's' ) 
 
@@ -4266,11 +4298,21 @@
                                           nzt_topo_nestbc_n, 'n', 's' )
 
+                IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+
+                   CALL pmci_interp_tril_sn( qc, qcc, ico, jco, kco, r1xo,     &
+                                             r2xo, r1yo, r2yo, r1zo, r2zo,     &
+                                             logc_u_n,                         &
+                                             logc_ratio_u_n, nzt_topo_nestbc_n,& 
+                                             'n', 's' )
+
+                   CALL pmci_interp_tril_sn( nc, ncc, ico, jco, kco, r1xo,     &
+                                             r2xo, r1yo, r2yo, r1zo, r2zo,     &
+                                             logc_u_n,                         &
+                                             logc_ratio_u_n, nzt_topo_nestbc_n,& 
+                                             'n', 's' )
+
+                ENDIF
+
                 IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-
-!                    CALL pmci_interp_tril_sn( qc, qcc, ico, jco, kco, r1xo,     &
-!                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-!                                              logc_u_n,                         &
-!                                              logc_ratio_u_n, nzt_topo_nestbc_n,& 
-!                                              'n', 's' )
 
                    CALL pmci_interp_tril_sn( qr, qrc, ico, jco, kco, r1xo,     &
@@ -4279,10 +4321,4 @@
                                              logc_ratio_u_n, nzt_topo_nestbc_n,& 
                                              'n', 's' )
-
-!                    CALL pmci_interp_tril_sn( nc, ncc, ico, jco, kco, r1xo,     &
-!                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
-!                                              logc_u_n,                         &
-!                                              logc_ratio_u_n, nzt_topo_nestbc_n,& 
-!                                              'n', 's' )
 
                    CALL pmci_interp_tril_sn( nr, nrc, ico, jco, kco, r1xo,     &
@@ -4317,7 +4353,10 @@
 
                    IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!                       CALL pmci_extrap_ifoutflow_sn( qc, 'n', 's' )
+                      CALL pmci_extrap_ifoutflow_sn( qc, 'n', 's' )
+                      CALL pmci_extrap_ifoutflow_sn( nc, 'n', 's' )
+                   ENDIF
+
+                   IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                       CALL pmci_extrap_ifoutflow_sn( qr, 'n', 's' )
-!                       CALL pmci_extrap_ifoutflow_sn( nc, 'n', 's' )
                       CALL pmci_extrap_ifoutflow_sn( nr, 'n', 's' )
                    ENDIF
@@ -4356,14 +4395,19 @@
                                    r2yo, r1zo, r2zo, 's' )
 
+          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+
+             CALL pmci_interp_tril_t( qc, qcc, ico, jco, kco, r1xo, r2xo, r1yo,&
+                                      r2yo, r1zo, r2zo, 's' )
+
+             CALL pmci_interp_tril_t( nc, ncc, ico, jco, kco, r1xo, r2xo, r1yo,&
+                                      r2yo, r1zo, r2zo, 's' )
+
+          ENDIF
+
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
 
-!              CALL pmci_interp_tril_t( qc, qcc, ico, jco, kco, r1xo, r2xo, r1yo,&
-!                                       r2yo, r1zo, r2zo, 's' )
 
              CALL pmci_interp_tril_t( qr, qrc, ico, jco, kco, r1xo, r2xo, r1yo,&
                                       r2yo, r1zo, r2zo, 's' )
-
-!              CALL pmci_interp_tril_t( nc, ncc, ico, jco, kco, r1xo, r2xo, r1yo,&
-!                                       r2yo, r1zo, r2zo, 's' )
 
              CALL pmci_interp_tril_t( nr, nrc, ico, jco, kco, r1xo, r2xo, r1yo,&
@@ -4394,8 +4438,11 @@
              CALL pmci_extrap_ifoutflow_t( q, 's' )
 
+             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                CALL pmci_extrap_ifoutflow_t( qc, 's' )
+                CALL pmci_extrap_ifoutflow_t( nc, 's' )
+             ENDIF
+
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-!                 CALL pmci_extrap_ifoutflow_t( qc, 's' )
                 CALL pmci_extrap_ifoutflow_t( qr, 's' )
-!                 CALL pmci_extrap_ifoutflow_t( nc, 's' )
                 CALL pmci_extrap_ifoutflow_t( nr, 's' )
 
@@ -4438,14 +4485,18 @@
                                   kfuo, ijfc_s, kfc_s, 's' )
 
+         IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+
+            CALL pmci_anterp_tophat( qc, qcc, kctu, iflo, ifuo, jflo, jfuo,    &
+                                     kflo, kfuo, ijfc_s, kfc_s, 's' )
+
+            CALL pmci_anterp_tophat( nc, ncc, kctu, iflo, ifuo, jflo, jfuo,    &
+                                     kflo, kfuo, ijfc_s, kfc_s,  's' )
+
+         ENDIF
+
          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-
-!             CALL pmci_anterp_tophat( qc, qcc, kctu, iflo, ifuo, jflo, jfuo,    &
-!                                      kflo, kfuo, ijfc_s, kfc_s, 's' )
 
             CALL pmci_anterp_tophat( qr, qrc, kctu, iflo, ifuo, jflo, jfuo,    &
                                      kflo, kfuo, ijfc_s, kfc_s, 's' )
-
-!             CALL pmci_anterp_tophat( nc, ncc, kctu, iflo, ifuo, jflo, jfuo,    &
-!                                      kflo, kfuo, ijfc_s, kfc_s,  's' )
 
             CALL pmci_anterp_tophat( nr, nrc, kctu, iflo, ifuo, jflo, jfuo,    &
